on 1:CONNECT: { .timer_tracker 1 60 tracker_query }

alias tracker_destroy { noop $xml.destroy($1) }
alias tracker_desc { return $iif(($1 != $null) && ($1 != <empty>),$shorten(312,$iif($right($1,1) == .,$left($1,-1),$1))) }
alias tracker_time {
  if ($1 > 0) {
    var %a = $calc($ctime - $1)
    if (%a > 0) { return $dur(%a) }
  }
  return 0
}
; ctime %tracker.creator %tracker.category %tracker.title %tracker.description
alias tracker_msg {
  var %t = $tracker_time($1)
  if ($3 == changeset) {
    if ($4 >= 0) {
      return $b($2) added revision $b($4) $iif(%t,$+($chr(40),%t ago,$chr(41))) $+(www.redeclipse.net/svn/,$4) $iif($5 != $null,-> $5)
    }
    else {
      var %v = $calc(6200 + $4)
      return $b($2) added revision $b($4) $+($chr(40),BR:,$b(%v),$chr(41)) $iif(%t,$+($chr(40),%t ago,$chr(41))) $+(www.redeclipse.net/old/,%v) $iif($5 != $null,-> $5)
    }
  }
  elseif (($3 == newticket) || ($3 == closedticket) || ($3 == reopenedticket) || ($3 == updatedticket)) {
    var %f = $left($3,-6)
    return $b($2) $iif(%f != new,%f,added) ticket $b($4) $iif(%t,$+($chr(40),%t ago,$chr(41))) $+(www.redeclipse.net/ticket/,$4) $iif($5 != $null,-> $5)
  }
  return $null
}
alias tracker_file {
  var %z = 0
  var %a = $lines($1)
  while (%a > 0) {
    var %c = $read($1,n,%a)
    var %d = $gettok(%c,1,32)
    if (%d isnum) {
      if (%d < $2) {
        inc %a
        var %z = %a
        var %a = 0 
      }
      elseif (%d == $2) { return }
    }
    dec %a
  }
  write $iif(%z != 0,$+(-il,%z)) $1 $2-
}
alias tracker_files {
  prints info tracker: $1-
  tracker_file tracker.txt $1-
  tracker_file tracker.msg $1-
}
alias tracker_read {
  var %a = $lines(tracker.msg)
  var %b = 1
  var %c = 1
  while (%a >= %b) {
    var %t = $read(tracker.msg,n,%b)
    var %s = $tracker_msg($gettok(%t,1,32),$gettok(%t,2,32),$gettok(%t,3,32),$gettok(%t,4,32),$tracker_desc($gettok(%t,5-,32)))
    if (%s != $null) { .timer 1 %c smsg freenode #redeclipse %s | inc %c }
    inc %b
  }
  write -c tracker.msg
}
alias tracker_timer {
  var %hh = $asctime(HH), %nn = $calc($asctime(nn) - ($asctime(nn) % 10) + 10)
  if (%nn >= 60) { inc %hh | if (%hh >= 24) { dec %hh 24 } | var %nn = 00 }
  .timer_tracker $+(%hh,:,%nn) 1 1 tracker_query
}
alias tracker_query {
  tracker_timer
  prints info Updating report..
  noop $xml.document(http://sourceforge.net/apps/trac/redeclipse/report/2?format=rss,tracker_report)
}
alias tracker_update {
  prints info Updating timeline..
  noop $xml.document(http://sourceforge.net/apps/trac/redeclipse/timeline?ticket=on&changeset=on&max=10&daysback=7&format=rss,tracker_feed)
}
alias tracker_feed {
  if (!$xml.parseError($1)) {
    var %o = 0
    var %n = $xml.selectNodeSet($1,//item)
    var %a = $xml.nodeSet(%n).length
    prints info Processing timeline..
    while (%a > 0) {
      dec %a
      var %z = $xml.nodeSet(%n,%a)
      var %s = $xml.selectNodeSet(%z,*)
      var %r = $xml.nodeSet(%s).length
      var %p = 0
      unset %tracker.*
      while (%r > %p) {
        var %l = $xml.nodeSet(%s,%p)
        var %bn = $xml.node(%l).baseName
        var %bi = 2
        while (%tracker. [ $+ [ %bn ] ] != $null) { var %bn = $+($xml.node(%l).baseName,%bi) | inc %bi }
        set %tracker. [ $+ [ %bn ] ] $xml.node(%l).text
        inc %p
      }
      if ($len(%tracker.guid) >= 2) {
        var %g = $right(%tracker.guid,-1)
        if (%g isnum) {
          var %q = $read(tracker.txt,nr,$by(%g,$bx(.*)),1)
          if (%q == $null) {
            var %y = $null
            set %tracker.description $iif(%tracker.description != $null,$shorten(400,$xmltidy(%tracker.description)),$null)
            if (%tracker.category == changeset) {
              var %v = $remove($gettok(%tracker.title,2,32),[,],:)
              set %tracker.title %v
              if (%tracker.description == $null) { set %tracker.description <empty> }
              var %y = %tracker.category
            }
            elseif ((%tracker.category == newticket) || (%tracker.category == closedticket) || (%tracker.category == reopenedticket)) {
              var %v = $remove($gettok(%tracker.title,2,32),$chr(35))
              var %w = $shorten(120,$left($right($gettok(%tracker.title,$+(3-,$calc($gettok(%tracker.title,0,32) - 1)),32),-1),-1))
              var %y = %tracker.category
              set %tracker.title %v
              set %tracker.description $iif(%tracker.category == closedticket,$iif(%tracker.description != $null,%tracker.description,unknown) $+($chr(40),%w,$chr(41)),%w)
              var %f = $left(%y,-6)
            }
            if (%y != $null) {
              tracker_files %g %tracker.creator %tracker.category %tracker.title %tracker.description
            }
          }
        }
      }
    }
  }
  else { prints info XML error: $remove($xml.parseError($1).print,$cr,$lf) }
  tracker_destroy $1
  prints info Tracker is now up to date.
  tracker_read tracker.msg
}
alias tracker_ticket {
  if (!$xml.parseError($1)) {
    var %i = $xml.node($1,//title).text
    var %h = $gettok(%i,3-,58)
    var %k = $xml.node($1,//link).text
    var %g = $gettok(%k,-1,47)
    prints info Processing ticket %g ..
    var %n = $xml.selectNodeSet($1,//item)
    var %a = $xml.nodeSet(%n).length
    var %b = 0
    while (%a > %b) {
      var %z = $xml.nodeSet(%n,%b)
      var %s = $xml.selectNodeSet(%z,*)
      var %r = $xml.nodeSet(%s).length
      var %p = 0
      unset %tracker.*
      while (%r > %p) {
        var %l = $xml.nodeSet(%s,%p)
        var %bn = $xml.node(%l).baseName
        var %bi = 2
        while (%tracker. [ $+ [ %bn ] ] != $null) { var %bn = $+($xml.node(%l).baseName,%bi) | inc %bi }
        var %bt = $xml.node(%l).text
        set %tracker. [ $+ [ %bn ] ] %bt 
        inc %p
      }
      var %t = $calc($ctime($left($remove(%tracker.pubDate,$chr(44)),-4)) + $ctime - $gmt)
      var %q = $read(tracker.txt,nr,$by(%t,$bx(.*)),1)
      if (%q == $null) {
        var %v = $iif(%tracker.title != $null,$shorten(400,$xmltidy(%tracker.title)),<empty>)
        if (resolution !isin %v) {
          var %u = $iif(%tracker.description != $null,$shorten(300,$xmltidy(%tracker.description)),$null)
          var %w = $iif(%u != $null,%u,%v) $iif(%h != $null,$+($chr(40),$shorten(120,$xmltidy(%h)),$chr(41)))
          tracker_files %t %tracker.creator updatedticket %g %w
        }
      }
      inc %b
    }
    .timer_tracker_tickets 1 1 tracker_tickets 1
  }
  else { prints info XML error: $remove($xml.parseError($1).print,$cr,$lf) }
  tracker_destroy $1
}
alias tracker_tickets {
  if (!$1) { prints info Processing $lines(tracker.tmp) ticket(s).. }
  elseif ($lines(tracker.tmp) > 0) { write -dl1 tracker.tmp }
  if ($lines(tracker.tmp) > 0) {
    var %c = $read(tracker.tmp,nt,1)
    if (%c isnum) {
      prints info Updating ticket %c ..
      noop $xml.document($+(http://sourceforge.net/apps/trac/redeclipse/ticket/,%c,?format=rss),tracker_ticket)
    }
  }
  else { .timer_tracker_update 1 1 tracker_update }
}
alias tracker_report {
  write -c tracker.tmp
  if (!$xml.parseError($1)) {
    var %o = 0
    var %n = $xml.selectNodeSet($1,//item)
    var %a = $xml.nodeSet(%n).length
    var %b = 0
    prints info Processing report..
    while (%a > %b) {
      var %z = $xml.nodeSet(%n,%b)
      var %s = $xml.selectNodeSet(%z,*)
      var %r = $xml.nodeSet(%s).length
      var %p = 0
      unset %tracker.*
      while (%r > %p) {
        var %l = $xml.nodeSet(%s,%p)
        var %bn = $xml.node(%l).baseName
        var %bi = 2
        while (%tracker. [ $+ [ %bn ] ] != $null) { var %bn = $+($xml.node(%l).baseName,%bi) | inc %bi }
        var %bt = $xml.node(%l).text
        set %tracker. [ $+ [ %bn ] ] %bt 
        inc %p
      }
      if ($len(%tracker.guid) >= 1) {
        var %g = $gettok(%tracker.guid,-1,47)
        if (%g isnum) {
          var %t = $calc($ctime($left($remove(%tracker.pubDate2,$chr(44)),-4)) + 36000)
          var %q = $read(tracker.txt,nr,$by(%t,$bx(.*)),1)
          if (%q == $null) { write tracker.tmp %g | var %o = 0 }
          elseif (%o == 0) { var %o = 1 }
          else { var %b = %a }
        }
      }
      inc %b
    }
  }
  else { prints info XML error: $remove($xml.parseError($1).print,$cr,$lf) }
  tracker_destroy $1
  .timer_tracker_tickets 1 1 tracker_tickets 0
}

alias botcmd_2_tracker {
  var %j = $readini($cfgini,bot,tracker)
  if ($4 == -help) { goto quote_help }
  elseif ($4 == -update) {
    if ($2 < 4) { bot_rmsg $3 $1 Sorry, you need level 4 or higher to update data. }
    else {
      bot_rmsg $3 $1 Updating tracker...
      tracker_query
    }
  }
  elseif ($4 == -stats) {
    bot_rmsg $3 $1 tracker stats -> $lines(tracker.txt) entries -> requested %j times
  }
  else {
    var %o = 0
    var %r = $null
    var %cn = 5
    var %dr = 0
    if ($4 != $null) {
      if (($4 == -revision) || ($4 == -changeset) || ($4 == -change)) {
        var %b = $5-
        if (($gettok(%b,0,58) == 2) && ($gettok(%b,1,58) == BR)) { var %b = $calc($gettok(%b,2,58) - 6200) }
        var %r = $by($bx([^ ]+),changeset,$iif(%b != $null,$by($br(%b),$bx(.*)),$bx(.*)))
      }
      elseif (($4 == -newticket) || ($4 == -new)) {
        var %r = $by($bx([^ ]+),newticket,$iif($5 != $null,$by($br($5-),$bx(.*)),$bx(.*)))
      }
      elseif (($4 == -closedticket) || ($4 == -closed)) {
        var %r = $by($bx([^ ]+),closedticket,$iif($5 != $null,$by($br($5-),$bx(.*)),$bx(.*)))
      }
      elseif (($4 == -reopenedticket) || ($4 == -reopened)) {
        var %r = $by($bx([^ ]+),reopenedticket,$iif($5 != $null,$by($br($5-),$bx(.*)),$bx(.*)))
      }
      elseif ($4 == -ticket) {
        var %r = $by($bx([^ ]+),$bx(newticket|closedticket|reopenedticket),$iif($5 != $null,$by($br($5-),$bx(.*)),$bx(.*)))
      }
      elseif (($4 == -description) || ($4 == -desc)) {
        var %r = $by($bx([^ ]+),$bx([^ ]+),$bx([^ ]+),$iif($5 != $null,$by($br($5-),$bx(.*)),$bx(.*)))
      }
      elseif ($4 == -last) {
        if ($5 isnum) { var %cn = $5 }
        else { var %dr = $dur($5) | var %cn = 100 }
        var %r = $iif($6 != $null,$br($6-),$bx(.*))
      }
      else { var %r = $br($4-) }
    }
    var %w = $null
    var %y = $lines(tracker.txt)
    var %z = 1
    if ((%r == $null) && (%cn > 0) && (%y > %cn)) { var %z = $calc(%y - %cn) | inc %o %z }
    while (%y >= %z) {
      var %a = $iif(%r != $null,$read(tracker.txt,nr,$by($bx([^ ]+),%r),%z),$read(tracker.txt,n,%z))
      if (%a != $null) {
        if ((%dr <= 0) || ($calc($ctime - $gettok(%a,1,32)) <= %dr)) {
          var %z = $readn
          if ($len(%w) >= 400) { var %w = $deltok(%w,1,32) | inc %o }
          var %w = $iif(%w != $null,$+(%w,$chr(32),%z),%z)
        }
      }
      else { var %z = %y }
      inc %z
    }
    if (%w != $null) {
      inc %j
      writeini -n $cfgini bot tracker %j
      var %n = $gettok(%w,0,32)
      var %m = 1
      while ((%n >= 1) && (%m <= %cn)) {
        var %a = $read(tracker.txt,n,$gettok(%w,%n,32))
        var %s = $tracker_msg($gettok(%a,1,32),$gettok(%a,2,32),$gettok(%a,3,32),$gettok(%a,4,32),$tracker_desc($gettok(%a,5-,32)))
        if (%s != $null) { bot_rmsg $3 $1 %s }
        inc %m
        dec %n
      }
      inc %n %o
      if (%n >= 1) { bot_rmsg $3 $1 Additionally, %n more $iif(%n != 1,entries,entry) matching $+(",$iif(%r != $null,%r,$iif($4 != $null,$4-,$bx(.*))),") were found }
    }
    else { bot_rmsg $3 $1 Sorry, no tracker items matching $+(",$iif(%r != $null,%r,$iif($4 != $null,$4-,$bx(.*))),") were found }
  }
  return
  :quote_help
  bot_rmsg $3 $1 tracker [<searchtext>|<-last> <dur or count>|<-update|-stats>|<-revision|-change[set]|-new[ticket]|-closed[ticket]|-reopened[ticket]|-ticket|-desc[ription]> <searchtext>]
}
